FORM COPR
=========

Type specification
==================
The new iff-form "COPR" is currently used by CopperPrefs only.
To give you the possibility to manipulate it or use it in your programs
I will describe in this article the "COPR"-form.

Please use the iffparse.library to manipulate files of the COPR-form
and always keep in mind that I'll enhance this format, i.e. I'll
make some chunks longer or I'll add new chunks.

The current length and amount of WAIT & MOVE-Chunks slows down read &
write-operations.

Chunks
======

0	LONG	"FORM"
4	LONG	(Size Of File)-8
8	LONG	"COPR"

COPI
----
Copper-Info. Read this to find out about the rest of this file.

0	LONG	"COPI"
4	LONG	(Size Of Chunk In Bytes)
8	LONG	Number of instructions

WAIT
----
This chunk contains only _ONE_ wait instruction.

0	LONG    "WAIT"
4	LONG	(Size Of Chunk In Bytes, usually 8)
8	LONG    Vertical Beam Pos to wait for
12	LONG	Horizontal Beam Pos to wait for


MOVE
----
This chunk contains only _ONE_ move instruction.

0	LONG    "MOVE"
4	LONG	(Size Of Chunk In Bytes, usually 8)
8	LONG    Number of color to change (not the address of the register!)
12	LONG    RGB-Value to load
