; *** GFXEQUATES.ASM

; *** GRAPHICS CONSTANTS

COMPLEMENT		EQU $2
EXTRA_HALFBRITE	EQU $80
HAM		EQU $800
HIRES		EQU $8000
INVERSVID		EQU $4
JAM1		EQU $0
JAM2		EQU $1
LACE		EQU $4

; *** GRAPHICS LIBRARY ROUTINE OFFSETS

LVO.BLTTEMPLATE	EQU $FFFFFFDC
LVO.CLEAREOL		EQU $FFFFFFD6
LVO.CLEARREGION	EQU $FFFFFDF0
LVO.CLEARSCREEN	EQU $FFFFFFD0
LVO.DRAW		EQU $FFFFFF0A
LVO.FLOOD		EQU $FFFFFEB6
LVO.GETRGB4		EQU $FFFFFDBA
LVO.LOADRGB4		EQU $FFFFFF40
LVO.MOVE		EQU $FFFFFF10
LVO.POLYDRAW		EQU $FFFFFEB0
LVO.READPIXEL		EQU $FFFFFEC2
LVO.RECTFILL		EQU $FFFFFECE
LVO.SETAPEN		EQU $FFFFFEAA
LVO.SETBPEN		EQU $FFFFFEA4
LVO.SETDRMD		EQU $FFFFFE9E
LVO.SETRGB4		EQU $FFFFFEE0
LVO.WRITEPIXEL		EQU $FFFFFEBC

; *** RASTPORT STRUCTURE OFFSETS

RP.FGPEN		EQU $19
RP.BGPEN		EQU $1A
RP.OPEN		EQU $1B
RP.DRAWMODE		EQU $1C

; *** VIEWPORT STRUCTURE OFFSETS

VP.COLORMAP		EQU $4
VP.MODES		EQU $20

; *** COLORMAP STRUCTURE OFFSETS

CM.FLAGS		EQU $0
CM.TYPE			EQU $1
CM.COUNT		EQU $2
CM.COLORTABLE		EQU $4

; *** BITMAP STRUCTURE OFFSETS

BM.BYTESPERROW		EQU $0
BM.ROWS			EQU $2
BM.FLAGS		EQU $4
BM.DEPTH		EQU $5
BM.PAD			EQU $6
