**
**	MacSND DataType
**
**	Written by Olaf `Olsen' Barthel <olsen@sourcery.han.de>
**		Public domain
**
** :ts=4
**

		INCLUDE "exec/types.i"
		INCLUDE	"exec/nodes.i"
		INCLUDE "exec/resident.i"

		INCLUDE	"macsnd.datatype_rev.i"

		XREF	_LibInitTab

		SECTION	text,CODE

*----------------------------------------------------------------------

		MOVEQ	#0,D0
		RTS

*----------------------------------------------------------------------

InitDesc:
		DC.W	RTC_MATCHWORD
		DC.L	InitDesc
		DC.L	EndCode
		DC.B	RTF_AUTOINIT
		DC.B	VERSION
		DC.B	NT_LIBRARY
		DC.B	0
		DC.L	_LibName
		DC.L	_LibID
		DC.L	_LibInitTab

EndCode:

*----------------------------------------------------------------------

		VERSTAG

*----------------------------------------------------------------------

		XREF	__BSSBAS
		XREF	__BSSLEN

		dc.l	__BSSBAS
		dc.l	__BSSLEN

*----------------------------------------------------------------------

		SECTION	data,data

*----------------------------------------------------------------------

		XDEF	_LibVersion
		XDEF	_LibRevision

_LibVersion:
		dc.w	VERSION

_LibRevision:
		dc.w	REVISION

*----------------------------------------------------------------------

		XDEF	_LibName

_LibName:
		dc.b	'macsnd.datatype',0

*----------------------------------------------------------------------

		XDEF	_LibID

_LibID:
		VSTRING

*----------------------------------------------------------------------

		END
