
#define MASK(n) (1L<<(n))

/* This structure defines the basic communications between the server
 * and the client.
 */
typedef struct ClientMessage {
	struct Message bcm_Message;
	struct RetinaScreen *bcm_Screen;
	LONG bcm_Status;
	ULONG bcm_SigMask;
};


/* Prototypes */

void *InitGraphics(struct ClientMessage*);

/* Pops up an error requestor. */

void Error(char *s);