#define BLUE_EYES_WIDE 80
#define BLUE_EYES_HIGH 24
#define GREEN_EYES_WIDE 80
#define GREEN_EYES_HIGH 24
#define VIOLET_EYES_WIDE 80
#define VIOLET_EYES_HIGH 24
#define BROWN_EYES_WIDE 80
#define BROWN_EYES_HIGH 48
#define EYES_COLS 8
#define EYES_COLS_BYTES 24

/*
 *  This defines one set of eyes.
 */
typedef struct {
    int width, height;
    int xpos, ypos;
    int old_xpos, old_ypos;
    int xspeed, yspeed;
    int tic, animspeed;
    int maxframes, currentframe;
    unsigned char **animtable;
} Eyes;

extern unsigned char color_table[];
extern Eyes VioletEyes, GreenEyes, BlueEyes, BrownEyes;
