
#include <clib/asl_protos.h>
#include <clib/exec_protos.h>
#include <clib/alib_stdio_protos.h>
#include <dos/dosasl.h>
#include <exec/libraries.h>

int CXBRK(void) { return(0); }
int chkabort(void) { return(0); }

UBYTE *vers = "\0$VER: FR 1";

void main(void);

struct Library *AslBase;

struct TagItem frtags[] =
{
    ASL_Hail,       (ULONG)"    >>  FR v1 <<   Requester   ",
    ASL_Height,     (UWORD)200,
    ASL_Width,      (UWORD)320,
    ASL_LeftEdge,   (UWORD)0,
    ASL_TopEdge,    (UWORD)0,
    ASL_OKText,     (ULONG)"O KAY",
    ASL_CancelText, (ULONG)"not OK",
    ASL_File,       (ULONG)" ",
    ASL_Dir,        (ULONG)"SYS:",
    TAG_DONE
};



void main()
{

    struct FileRequester *fr;

    if (AslBase = OpenLibrary("asl.library", 36L))
    {
        if (fr = (struct FileRequester *)
            AllocAslRequest(ASL_FileRequest, frtags))
        {

            if (AslRequest(fr, 0L))
                printf("file choice = %s%s\n", fr->rf_Dir, fr->rf_File);
            else
                printf("User Cancelled\n");

        }

        FreeAslRequest(fr);
    }
    CloseLibrary(AslBase);
}
