/*
** GaugeClass V0.9 used for TinyMeter
**
** Header file also for hismeter class!!!
*/

#include <utility/tagitem.h>

/* Setable only Tags */

#define GAU_Type_gauge          0
#define GAU_Type_histmeter      1
#define GAU_Type_clock          2

#define GAU_TextFont            (TAG_USER + 1 )
#define GAU_Min                 (TAG_USER + 2 )
#define GAU_Max                 (TAG_USER + 3 )
#define GAU_Current             (TAG_USER + 4 )
#define GAU_Base                (TAG_USER + 5 )
#define GAU_TextFormat          (TAG_USER + 6 )
#define GAU_Label               (TAG_USER + 7 )
#define GAU_LabelPos            (TAG_USER + 8 )
#define GAU_FmtIndent           (TAG_USER + 9 )
#define GAU_Type                (TAG_USER + 10)

#define GAU_3D                  (TAG_USER + 16)
#define GAU_Border              (TAG_USER + 17)
#define GAU_Background          (TAG_USER + 18)
#define GAU_ShadowLabel         (TAG_USER + 19)
#define GAU_NoGauge             (TAG_USER + 20)
#define GAU_NoFormat            (TAG_USER + 21)
#define GAU_NoBase              (TAG_USER + 22)

#define GAU_ColLabel            (TAG_USER + 32)
#define GAU_ColFormat           (TAG_USER + 33)
#define GAU_ColBase             (TAG_USER + 34)
#define GAU_ColCurrent          (TAG_USER + 35)
#define GAU_ColNegative         (TAG_USER + 36)
#define GAU_ColBrightEdg        (TAG_USER + 37)
#define GAU_ColDarkEdg          (TAG_USER + 38)
#define GAU_ColBackground       (TAG_USER + 39)

#define GAU_UsedColors  8

/* Gettable only Tags */

#define GAU_RPBackground        (TAG_USER + 64)

struct  GAU_Color
{
    UWORD   pen;
    ULONG   red;    /* if pen is TRUE, this is the pen number */
    ULONG   green;
    ULONG   blue;
};

