CGWBPattern                        Manual                            CGWBPattern

	NAME
	
      CGWBPPatch      	 - Main program

      Prefs/CGWBPattern  - Prefs
	
	
	INTRODUCTION
	
		CyberGraphics has the wonderful feature that you can have a Workbench
		with a serious quantity of colours.. Ever since i got my graphics card
		and CyberGraphics i wanted to have a jpeg as a backdrop.. Would sure
		look pretty, So i started to write CGWBPattern, and with the writing
		it grew until it turned into what it is now.. A complete replacement
		for WBPattern, with additional gimics ;-)


	FEATURES
		
		Backdrop (pattern) updating (refreshing) is significantly faster then
		WBPattern.

		Uses datatypes to load patterns

		6 different colour remap types (precisions).

		Change the Screenmode and the backdrop remaps to the new number of
		colours to insure the backdrops always look as good as possible.

		CyberGraphics users can have 15/16/24bit backdrops using the
		24bit picture.datatype.
	
		Optional random backdrops.

		Workbench windows can be changed to smart refresh for even faster
		pattern updating

		FullWB toggle (with optional 'screen-to-front/back' gadget)

		Prefs program for easy setting.

		Memory used by patterns can be varied.

		Optional Centering

		3 placement types - pattern can be tiled, not tiled or scaled to
		the size of the Workbench    	

	INSTALLATION

		One off
		
		1. Copy bgui.library to libs: or do 'assign libs: libs add' from
			the CGWBPattern dir.
		
		2.	Just execute 'CGWBPPatch' then play with the prefs prog.
	
		Perminant
		
		1. Open up WBPattern prefs, set to blank patterns.. Save (otherwise
			you'll waste mem.).

		2. Copy Prefs/CGWBPattern to whereever you put your prefs progs.
		
		3. Copy bgui.library to libs:

		4. Copy CGWBPPatch to c: or whereever.

		5. Add 'CGWBPPatch' to your startup-sequence sometime <after>
			'AddDatatypes' (it auto-detaches so no need to run it..).
			
		6. Play with the Prefs prog.  	

	
	USAGE
	
		CGWBPPatch

			Execute it once to patch the system, once more to remove the
			patches (NB this can be dangerous.. If another program has
			patched the same functions your system may guru).		
		
		Prefs/CGWBPattern
		
		 - Gadgets (all have keyboard shortcuts)
		
		 	Workbench/Windows
		 		
		 		'Directory' ('Random' checked)
		 		
		 			Directory name from which the patterns are chosen, either
					enter by hand or click on the file requester gadget.


				'Pattern' ('Random' not checked)

					Pattern to use, either enter by hand or click on the file
					requester gadget.
				

				'Precision'
				
					Remap precision to use. the higher the precision the better
					the backdrops will look, however the higher the precision the
					longer the backdrops will take to load.. Experiment.
					
						Precision

						worst -----> best
						
						GUI (1) -> Icon (2) -> Image (3) -> Exact (4)
						
						The Precisions are in this order in the cycle gad.
					
					Planes precision is no remapping at all.. Useful if, for
					example, you use MagicWB with only 8 colours and your
					patterns use these colours in the same order as the WB -
					Remapping, in this case, is not ness. so why not switch it
					off and gain some speed in loading?

					Another use that springs to mind.. Seen those ArcPacks?
					with about 10ish different sets of colours... Rather
					than make a new copy of the pattern with different colours
					just change the WB Colours..
										
					
					CyberGfx precision is only usable by those with CyberGraphics
					supported Graphics Cards.. Allows you to use 15/16/24 bit
					patterns (backdrops).
					

				'Smart'
				
					Check this if you want the Workbench Window (or the Drawer
					windows) to be smart refresh instead of simple refresh -
					Smart refresh windows are faster to refresh but take up
					more memory.
					
					Don't check 'Smart' for the Workbench if you're in a
					CyberGraphics screemode with a depth greater than 8.
				

				'Random'
				
					Check this if you want random patterns.
					
					A random pattern will be loaded each time the prefs changes
					(apart from 'WB Gadget' - toggling this has no effect on the
					patterns) or is read by CGWBPPatch (ie on startup or if you
					change the screenmode).
				
				'Position'

					3 Positions available

					'Tile' tiles the pattern across the WB/Window

					'Picture' doesn't tile the pattern, and fills the rest of
 					the display with the colour at the topleft corner of the
 					pattern.

					'Scale' is the same as 'Picture' only the
					pattern is scaled to the size of the WB Screen

					NB if there's not enough memory free to scale the picture
					'Scale' falls back to 'Picture', if 'Picture' fails then
					'Tile' is tried.
					
					Although it is perfectly ok to 'Scale' or 'Picture' a
					pattern for drawers, the two use the size of the screen
					rather than the current window.  This is unlikely to change
					as if CGWBPattern did a 'Scale' or 'Picture' for every window
					opening it would make your WB rather slow.
					
				'Center Y'

					Check this and the pattern will be vertically centered within
					each window.

				'Center X'

					Check this and the pattern will be horozonally centered within
					each window.	

			'Full WB'

				Check this and the Workbench titlebar will be hidden (the
				Workbench pattern will occupy the whole screen).
			
				This only makes sence if the Workbench window is borderless.
				
				NB CGWBPattern uses electronic countermeasures ;-) to make
				sure the Workbench stays full or not. If you have several
				programs that toggle 'Full WB' running, the important one
				is this (trust me).
					

			'WB Gadget'

				If you have a 'Full WB' but you want a 'Screen to front/back'
				gadget anyway check this.

	
			'Mem Size'

				Controls the way CGWBPattern allocates the memory for the
				patterns..

					'Minimum'

						Smallist allocation - least memory taken.. Slowest
						refresh.

					'Standard'

						Normal memory allocation. Normal refresh

					'Maximum'

						Largest memory allocation, fastest refresh.

			
			'Save'

				Saves the current settings to env: & envarc:


			'Use'

				Saves the current settings to env: (reboot and you'll
				get the old settings back)


			'Test'					
					
				Shows you what the current settings look like without commiting
				you to them (when you quit the prefs the prevous settings will
				be restored).
	
	
			'Cancel'

				Quit the preferences loosing any changes made.					
					
	
		 - Menus
		
			'Project'

				'Open...'
				
					Load a previously saved prefs file.

				'Save as...'
				
					Save the prefs as..

				'About...'
				
					Pretty little window.

				'Quit'
					
					Quit the preferences loosing any changes made.	
					

			'Edit'

				'Last Saved'
				
					Re-loads the preferences from envarc:

				'Restore'	 	
				
					Re-loads the preferences from env:

	
	BUGS/PROBLEMS
	
		If you change a drawer to 'View by Icon' without closing/re-opening
		the drawer, currently the pattern will not appear.
		
		CGWBPattern does not work with EGS (this <MAY> be changed).
		I don't use it with EGS and no-one has yet written to me saying
		that they do (well want to..).
		
		Yak Users:
		
		The FullWB in CGWBPattern & the FullWB in Yak sometimes do not get
		on.. If you have FullWB set in CGWBPattern but not in Yak then you'll
		sometimes get a visable titlebar. The thing to do is set FullWB in Yak
		to TRUE (even if you don't want a full wb) and forget it. If you want a
		full Wb tick FullWB in CGWBPattern, if you don't don't.
		
		Other FullWB Programs:
		
		In general won't actually do anything (although some <may> have a similar
		problem to Yak).


   SPECIAL REQUIREMENTS

   	Needs OS 3.00 or higher.
   	CyberGraphics, Supported Gfx Card & the 24bit picture.datatype
		to use the 15/16/24bit Precision.
		bgui.library needed for preferences editor (included).


	DISTRIBUTION
	
		CGWBPatternXXX (dir)

          Prefs (dir)
            CGWBPattern
				CGWBPattern.info
				
          CGWBPPatch
			 CGWBPattern.man
   	    CGWBPatternXXX.readme



          libs (dir)
            bgui.library         (c) Jan van den Baard

			 Calvin.iff24				(c) Unknown
			 Planet.iff24				(c> Unknown

   AUTHOR

      Simon Richardson
      simon@albert.demon.co.uk


   COPYRIGHT

      Simon Richardson 1995.


   PRICE

      CGWBPattern is emailware (if you like it let me know)


   DISTRIBUTABILITY

      Freely Distributable, (c) 1994-95 Simon Richardon


   DISCLAMER

		Standard boring disclamer that no-one reads anyway, about everything
		being due to the law of chance and not my fault at all (and definitly
		not my resposibility).. You know the old "use at your own peril" thingy..
		Humm do you think they put that on razors? "If you accidently cut off part
		of your body with this thing, or it explodes etc etc..". Makes you wonder
		doesn't it?

      If you like it, use it.. If you hate it delete it.


   HISTORY

	1.0 	26/10/95 First version


	1.01 	26/10/95	(First Aminet release)
  	
 						Can now set the window refresh type (NB don't make CGfx
						windows smart refresh)

						Can optionally remove the Workbench title bar
	
	CGWBPPatch					

		1.02	04/01/96		Added electronic contermeasures ;-)
								BugFix: CGWBPPatch now unload patterns before quiting
								(oops).
								Only resets the WB if it needs to rather than every
								time its prefs changes.
								Added WB Gadget
								The Workbench window always has its own pattern even
								if its not borderless now.
								'View by name' now works correctly
								CGWBPPatch now detaches from the CLI again.
								Now loads random files.
								Changed the name slightly for clarity.
								Misc small code changes and optimisations
								
		1.03	06/01/96		(Aminet Release)
		
								BugFix: Solved problem with stacksize caused by the
								additional code for random patterns.
								
		1.04					Added Planes precision

		1.041	14/01/96		BugFix: ShowTitle() would reset the WB sometimes
								when unness.
								
		1.05	23/01/96		Now uses 24bit picture.datatype for CyberGfx
								precision (also reduces code size & speeds
								up loading & refreshing slightly..)	

		1.06	29/01/96		Fixed the two enforcer hits that the patch was causing
								(haven't had a hit for some days now, so hopefully
								they're all gone..)

								Some internal modifications

								Fixed offset problem which caused the patterns to be
								incorrectly refreshed if a drawer was moved & enlarged.

								Added code for centering & positioning	

		1.07	07/02/96		BugFix: The positioning of the pattern on the WB Window
								was sometimes incorrect.

								Preferences loading re-written, now faster & much nicer
								(unfortunatly also incompatable with previous releases).
								Which should fix the problems some people where having.

								Code has been optimised some more & modified in places.

								Workbench now resets only when a preferences change makes
								it nessesary.

								FullWB handling changed.. Only resets if it has to.				
								
								
	Prefs/CGWBPattern

		1.02	17/12/95		Added new gadgets, tided up GUI.

		1.03	03/01/96		Filename gadget now knows about dirs.

		1.04  				Added Planes precision.	

		1.05	24/01/96		Added gadgets & code for positioning & centering

		1.06	04/02/96		Preferences saving/loading re-written.	Which should fix
								the problems some people where having (also faster).

														

   THANKS

		Jan van den Baard for  BGUI Library, i thought i'd try it for the
		prefs editor.. Now i love it..

		Pierre Carrette & Walter Drwald for your excellent 'layerhook'
		example.


 		