CGWBPattern                           Manual                            CGWBPattern

   NAME

      CGWBPattern
      Prefs/CGWBPattern

   SYNOPSIS

      CGWBPattern

      Send it a break (CTRL-C) to quit.

		Prefs/CGWBPattern
		

   DESCRIPTION

   	CGWBPattern
   	
   	Well it's a replacement for WBPattern, you can specify the precision for
		the picture you want to use (ie the quality of the picture), you can get
		rid of the Wb Titlebar if you want and you can make your WB windows
		smart refresh instead of simple if you want..
		
		Even if you're not bothered by precision and you don't have a Gfx Card
		You'll find that CGWBPattern is faster than WBPattern.
   	
   	For all precision's apart from 'CyberGfx' CGWBPattern uses datatypes to
   	load the picture, so you can load any picture you have a datatype for.
   	
   	CGWBPattern supports CyberGfx - Currently if you set the precision to
   	'CyberGfx' then a 24bit loader will be used and the picture will be
   	displayed in glorious 15/16/24bit..
   	
   	NB Currently the 24bit loader only supports the ilbm format rgb8,
   	reason being i'm waiting for the 24bit picture class to be released..

		Just put "run > nil: CGWBPattern" somewhere in your startup sequence after
		"LoadDatatypes" but before "LoadWB" (preferably several commands before "LoadWB")
		for perminate usage.
		
		Copy bgui.library to libs: if you haven't got it..
		
		Just type "CGWBPattern" to have a look at it.
		
		Don't put it in the WBStartup drawer.. When it starts up CGWBPattern will reset the
		Workbench if the screen is open (putting CGWBPattern in the startup-sequence avoids
		this and looks much nicer).

		Prefs/CGWBPattern

		Humm pretty straight forward stuff here, if you want to get rid of the titlebar
		click on 'Full WB', if you want smart refresh windows click on that etc..


   ERRORS

   	Haven't noticed any so far and i use the thing every time i boot..


   BUGS/PROBLEMS

   	CGWBPattern doesn't like EGS.. Not sure why.. The main program just crashes
   	on startup..
   	
   	FullWB and Yak.
   	
   	If you use yak then you must make sure the FullWB setting on yak matches
   	the setting on CGWBPattern.. Otherwise you may not yet what you want..
   	(fullwb or not), this is not a bug in either program.. But mearly the way
   	Yak works.. (ie if the Wb is 'full' and Yak is started without 'FullWB'
   	being set then it'll change the Wb back to having a visable titlebar..
   	
   	
	NOTES
	
		Order of better precision.

		GUI -> Icon -> Image -> Exact -> CyberGfx

		Why not just use 'Exact' for everything? ... Well, 'Exact' takes longer
		to load and ties up more pens.. Also some pictures actually look better
		set to 'Icon' or 'Image'..

		CyberGraphics users: If your WB Backdrop window is 15bit or more do
		not make it smart refresh.. It will cock up (probably..), (If you
		use 'CyberGfx' precision smart refresh is ignored anyway..).
		
		24 Bit loader currently only supports rgb8 format pictures.
		
		If you use CGWBPattern then make sure the WBPattern prefs are
		empty.. If you have a picture specified there that will be loaded
		as well.. (just not displayed... waste of mem./time).
		
		No support for a picture on the WB Screen.. Why? .. Well i always
		have the WB Backdrop window borderless.. and it would require more
		patches.. (which i don't like).
		
		CGWBPattern won't stop the WB being closed (ie though a screenmode
		change), but re-opening the WB will take slightly longer
		as CGWBPattern un-loads its pictures when the WB Closes (this
		makes sence if you think about it.. The new WB could well have
		a different number of colours.. So you want the backdrop picture
		to remap using those.. so it always looks as nice as possible..)
		
		The first time you open a Drawer will also take slightly longer
		as the drawer backdrop is loaded (but thereafter everything is
		fast again).


   SPECIAL REQUIREMENTS

   Needs OS 3.00 or higher.
   CyberGraphics & a Supported Gfx Card to use the 15/16/24bit Precision.
	bgui.library needed for preferences editor (included).

   AUTHOR

      Simon Richardson
      simon@albert.demon.co.uk

   COPYRIGHT

      Simon Richardson 1995.

   PRICE

      CGWBPattern is emailware (if you like it let me know)

   DISTRIBUTABILITY

      Freely Distributable, (c) 1994-95 Simon Richardon

   DISCLAMER

		Standard boring disclamer that no-one reads anyway, about everything
		being due to the law of chance and not my fault at all (and definitly
		not my resposibility).. You know the old "use at your own peril" thingy..
		Humm do you think they put that on razors? "If you accidently cut off part
		of your body with this thing, or it explodes etc etc..". Makes you wonder
		doesn't it?

      If you like it, use it.. If you hate it delete it.

   HISTORY

	  	1.01 (First Aminet release)
  	
 		Can now set the window refresh type (NB don't make CGfx windows
		smart refresh)

		Can optionally remove the Workbench title bar 	

   	1.0

		First version

   THANKS

		Jan van den Baard for  BGUI Library, i thought i'd try it for the
		prefs editor.. Now i love it..

		Pierre Carrette & Walter Drwald for your excellent 'layerhook'
		example.

   EXCUSES

   	This manual is not esp. good, but at 2.50 in the morning.. ;-)
   	
   	