; *** DOSEQUATES.ASM

; *** DOS LIBRARY ROUTINE OFFSETS

FH.TYPE			EQU $8

LVO.CLOSE		EQU $FFFFFFDC
LVO.CURRENTDIR		EQU $FFFFFF82
LVO.PARENTDIR		EQU $FFFFFF2E
LVO.DELAY		EQU $FFFFFF3A
LVO.INPUT		EQU $FFFFFFCA
LVO.OPEN		EQU $FFFFFFE2
LVO.OUTPUT		EQU $FFFFFFC4
LVO.READ		EQU $FFFFFFD6
LVO.WRITE		EQU $FFFFFFD0
LVO.EXECUTE		EQU $FFFFFF22
LVO.LOCK		EQU $FFFFFFAC

MODE_NEWFILE		EQU $3EE
MODE_OLDFILE		EQU $3ED
ACCESS_READ		EQU -2
SHARED_LOCK		EQU -2
EXECUTIVE_LOCK		EQU -1
ACCESS_WRITE		EQU -1

; *** PROCESS STRUCTURE OFFSETS

PROC.CLI		EQU $AC
PROC.CONSOLETASK	EQU $A4
PROC.MSGPORT		EQU $5C
PROC.STACKBASE		EQU $90
PROC.STACKSIZE		EQU $84
PROC.TASK		EQU $0
PROC.TASKNUM		EQU $8C
PROC.WINDOWPTR		EQU $B8

TICKSPERSECOND		EQU 50

